#include <stdio.h>
#include <stdlib.h>

long int f(long int n)
{
    if (n <= 0)
        n = 0;
    if(n > 1)
        n =  f(n-2)+f(n-1);
    return n;
}

int inicializujPole(long int **pole,unsigned int *ROZMER)
{
    printf("Zadejte rozmer pole: ");
    scanf("%d",ROZMER);
    
    if((*ROZMER) <= 0) {
        printf("rozmer musi byt > 0\n");
        return 1;
    }
    *pole = (long int *) malloc((*ROZMER)*sizeof(long int));
    if(!*pole) {
        printf("Pole se nezdarilo inicializovat.\n");
        return 1;
    }

    return 0;
}

void uvolniPole(long int *pole)
{
    free(pole);
}

void nactiCisla(long int *pole, unsigned int ROZMER)
{
    int i;
    for(i = 0; i < ROZMER; i++)
    {
        printf("Zadejte cislo %d: ",i);
        scanf("%ld",pole+i);
        if(pole[i] == 0)
            return;
    }
}

void vypisCisla(long int *pole, unsigned int ROZMER)
{
    int i;
    for(i = 0; i < ROZMER; i++)
    {
        if(!*(pole+i)) break;
        printf("%ld ", *(pole +i));
    }
    printf("\n");
}

void prumernaHodnotaLichychCisel(long int *pole,unsigned int ROZMER)
{
    unsigned int i, j=0;
    double prumer = 0.0;
    for(i = 0; i < ROZMER; i++)
    {
        if(!pole[i]) break;
        if(i%2) {
            prumer +=pole[i];
            j++;
        }
    }
    if(!j) j = 1;
    printf("Prumerna hodnota lichych cisel je %lf / %d = %lf\n",prumer,j,prumer/j);
}

void fibonacihoPosloupnostSudychCisel(long int *pole,unsigned int ROZMER)
{
    unsigned int i;
    long int j = 0;
    for(i = 0; i < ROZMER; i++)
    {
        if(!pole[i]) break;
        if(!(i%2)) {
            if(!j) {
                j= 1;
                while(pole[i] > f(j)) // hledam zacatek f.posloupnosti
                    j++;
            } else {
                j++;
            }
            if(f(j) != pole[i]) { // 0  1 1 2 3 5 8 13 21 34 55 ...
                 if(j == 1 && pole[i] == 2)  {
                    j++; continue;
                 }
                 printf("Suda cisla NETVORI fibonaciho posloupnost.\n");
                return;
            }
            //else printf("f(%ld)%ld == pole[%d]%ld\n",j,f(j),i,pole[i]);
        }
    }
    printf("Suda cisla TVORI fibonaciho posloupnost.\n");
}

int main(void)
{
    unsigned int ROZMER = 0;
    long int *pole = NULL;

    if(inicializujPole(&pole,&ROZMER)) {
        return 1;
    }

    nactiCisla(pole,ROZMER);
    vypisCisla(pole,ROZMER);
    prumernaHodnotaLichychCisel(pole,ROZMER);
    fibonacihoPosloupnostSudychCisel(pole,ROZMER);
    uvolniPole(pole);

    return 0;
}
